/**
 * Defines an operation yielding a value incremented continuously across a range.
 *
 * @typedef {object} Phaser.Types.GameObjects.Particles.EmitterOpEaseConfig
 * @since 3.0.0
 *
 * @property {number} start - The starting value.
 * @property {number} end - The ending value.
 * @property {boolean} [random] - If true, the particle starts with a minimum random value between the start and end values.
 * @property {(string|function)} [ease='Linear'] - The ease to find. This can be either a string from the EaseMap, or a custom function.
 * @property {number[]} [easeParams] - An optional array of ease parameters to go with the ease.
 */
